package com.dominikdorn.lyrix.domain;

import javax.persistence.*;
import java.util.Date;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@Table(name = "lytuserartistfavorite", schema = "lyriks")
@Entity
public class FavoriteArtist {

    @Id
    @Column(name = "nuserartistfavoritenr")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "artist_favorite_gen")
    @SequenceGenerator(name = "artist_favorite_gen",
            sequenceName = "lytuserartistfavorite_nuserartistfavoritenr_seq",
    allocationSize = 1)
    private int id;


    @Column(name = "nusernr")
    @Basic
    private int userId;

    @ManyToOne
    @JoinColumn(name = "nartistnr", referencedColumnName = "nartistnr", nullable = false)
    private Artist artist;

    @Column(name = "dnow")
    @Basic
    @Temporal(TemporalType.TIMESTAMP)
    private Date creationDate;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        FavoriteArtist that = (FavoriteArtist) o;

        if (id != that.id) return false;
        if (userId != that.userId) return false;
        if (creationDate != null ? !creationDate.equals(that.creationDate) : that.creationDate != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id;
        result = 31 * result + userId;
        result = 31 * result + (creationDate != null ? creationDate.hashCode() : 0);
        return result;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public int getUserId() {
        return userId;
    }

    public void setUserId(int userId) {
        this.userId = userId;
    }

    public Artist getArtist() {
        return artist;
    }

    public void setArtist(Artist artist) {
        this.artist = artist;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }
}