package com.dominikdorn.lyrix.domain;

import javax.persistence.*;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@Table(name = "lytlabel", schema = "lyriks")
@Entity
public class Label {
    @Id
    @Column(name = "nlabelnr")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "label_gen")
    @SequenceGenerator(name = "label_gen", sequenceName = "lytlabel_nlabelnr_seq", allocationSize = 1)
    private int id;

    @Column(name = "slabel")
    @Basic
    private String name;


    @Column(name = "sstreet")
    @Basic
    private String street;

    @Column(name = "shousenr")
    @Basic
    private String houseNumber;

    @Column(name = "spostalcode")
    @Basic
    private String postalCode;


    @Column(name = "stown")
    @Basic
    private String town;


    @Column(name = "scountryshort")
    @Basic
    private String countryCode;


    @Column(name = "stelephone")
    @Basic
    private String telephone;


    @Column(name = "stelefax")
    @Basic
    private String telefax;

    @Column(name = "semail")
    @Basic
    private String emailAddress;

    @Column(name = "surl")
    @Basic
    private String url;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Label label = (Label) o;

        if (id != label.id) return false;
        if (countryCode != null ? !countryCode.equals(label.countryCode) : label.countryCode != null)
            return false;
        if (emailAddress != null ? !emailAddress.equals(label.emailAddress) : label.emailAddress != null) return false;
        if (houseNumber != null ? !houseNumber.equals(label.houseNumber) : label.houseNumber != null) return false;
        if (name != null ? !name.equals(label.name) : label.name != null) return false;
        if (postalCode != null ? !postalCode.equals(label.postalCode) : label.postalCode != null) return false;
        if (street != null ? !street.equals(label.street) : label.street != null) return false;
        if (telefax != null ? !telefax.equals(label.telefax) : label.telefax != null) return false;
        if (telephone != null ? !telephone.equals(label.telephone) : label.telephone != null) return false;
        if (town != null ? !town.equals(label.town) : label.town != null) return false;
        if (url != null ? !url.equals(label.url) : label.url != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id;
        result = 31 * result + (name != null ? name.hashCode() : 0);
        result = 31 * result + (street != null ? street.hashCode() : 0);
        result = 31 * result + (houseNumber != null ? houseNumber.hashCode() : 0);
        result = 31 * result + (postalCode != null ? postalCode.hashCode() : 0);
        result = 31 * result + (town != null ? town.hashCode() : 0);
        result = 31 * result + (countryCode != null ? countryCode.hashCode() : 0);
        result = 31 * result + (telephone != null ? telephone.hashCode() : 0);
        result = 31 * result + (telefax != null ? telefax.hashCode() : 0);
        result = 31 * result + (emailAddress != null ? emailAddress.hashCode() : 0);
        result = 31 * result + (url != null ? url.hashCode() : 0);
        return result;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getStreet() {
        return street;
    }

    public void setStreet(String street) {
        this.street = street;
    }

    public String getHouseNumber() {
        return houseNumber;
    }

    public void setHouseNumber(String houseNumber) {
        this.houseNumber = houseNumber;
    }

    public String getPostalCode() {
        return postalCode;
    }

    public void setPostalCode(String postalCode) {
        this.postalCode = postalCode;
    }

    public String getTown() {
        return town;
    }

    public void setTown(String town) {
        this.town = town;
    }

    public String getCountryCode() {
        return countryCode;
    }

    public void setCountryCode(String countryCode) {
        this.countryCode = countryCode;
    }

    public String getTelephone() {
        return telephone;
    }

    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }

    public String getTelefax() {
        return telefax;
    }

    public void setTelefax(String telefax) {
        this.telefax = telefax;
    }

    public String getEmailAddress() {
        return emailAddress;
    }

    public void setEmailAddress(String emailAddress) {
        this.emailAddress = emailAddress;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }
}