package com.dominikdorn.lyrix.domain;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlRootElement;
import java.util.Date;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@Table(name = "lyttextcomment", schema = "lyriks")
@Entity
@XmlRootElement
public class TextComment {
    @Id
    @Column(name = "ntextcommentnr")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "textcomment_gen")
    @SequenceGenerator(
            name = "textcomment_gen", sequenceName = "lyttextcomment_ntextcommentnr_seq",
    allocationSize = 1)
    private int id;



    @Column(name = "dnow")
    @Basic
    @Temporal(TemporalType.TIMESTAMP)
    private Date creationDate;


    @Column(name = "ntextnr")
    @Basic
    private int textId;

    @Column(name = "nusernr")
    @Basic
    private int userId;


    @Column(name = "nstatusnr")
    @Basic
    private int statusId;

    @Column(name = "stitle")
    @Basic
    private String title;

    @Column(name = "stext")
    @Basic
    private String text;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        TextComment that = (TextComment) o;

        if (statusId != that.statusId) return false;
        if (id != that.id) return false;
        if (textId != that.textId) return false;
        if (userId != that.userId) return false;
        if (creationDate != null ? !creationDate.equals(that.creationDate) : that.creationDate != null) return false;
        if (text != null ? !text.equals(that.text) : that.text != null) return false;
        if (title != null ? !title.equals(that.title) : that.title != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id;
        result = 31 * result + (creationDate != null ? creationDate.hashCode() : 0);
        result = 31 * result + textId;
        result = 31 * result + userId;
        result = 31 * result + statusId;
        result = 31 * result + (title != null ? title.hashCode() : 0);
        result = 31 * result + (text != null ? text.hashCode() : 0);
        return result;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public int getTextId() {
        return textId;
    }

    public void setTextId(int textId) {
        this.textId = textId;
    }

    public int getUserId() {
        return userId;
    }

    public void setUserId(int userId) {
        this.userId = userId;
    }

    public int getStatusId() {
        return statusId;
    }

    public void setStatusId(int statusId) {
        this.statusId = statusId;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getText() {
        return text;
    }

    public void setText(String text) {
        this.text = text;
    }
}