package com.dominikdorn.lyrix.domain;

import javax.persistence.*;
import java.util.Date;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@Table(name = "lyttexthide", schema = "lyriks")
@Entity
public class TextHideEntry {

    @Id
    @Column(name = "ntexthidenr")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "texthide_gen")
    @SequenceGenerator(name = "texthide_gen", sequenceName = "lyttexthide_ntexthidenr_seq", allocationSize = 1)
    private int id;


    @Column(name = "stexthash")
    @Basic
    private String textHash;


    @Column(name = "nusernr")
    @Basic
    private int userId;


    @Column(name = "dnow")
    @Basic
    @Temporal(TemporalType.TIMESTAMP)
    private Date creationDate;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        TextHideEntry that = (TextHideEntry) o;

        if (id != that.id) return false;
        if (userId != that.userId) return false;
        if (creationDate != null ? !creationDate.equals(that.creationDate) : that.creationDate != null) return false;
        if (textHash != null ? !textHash.equals(that.textHash) : that.textHash != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id;
        result = 31 * result + (textHash != null ? textHash.hashCode() : 0);
        result = 31 * result + userId;
        result = 31 * result + (creationDate != null ? creationDate.hashCode() : 0);
        return result;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getTextHash() {
        return textHash;
    }

    public void setTextHash(String textHash) {
        this.textHash = textHash;
    }

    public int getUserId() {
        return userId;
    }

    public void setUserId(int userId) {
        this.userId = userId;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }
}