package com.dominikdorn.lyrix.domain;

import javax.persistence.*;
import java.util.Date;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@Table(name = "lyttextlog", schema = "lyriks")
@Entity
public class TextLogEntry {

    @Id
    @Column(name = "ntextlognr")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "text_log_gen")
    @SequenceGenerator(name = "text_log_gen", sequenceName = "lyttextlog_ntextlognr_seq", allocationSize = 1)
    private int id;

    @Column(name = "dnow")
    @Basic
    @Temporal(TemporalType.TIMESTAMP)
    private Date creationDate;

    @Column(name = "ntextnr")
    @Basic
    private int textId;

    @Column(name = "nusernr")
    @Basic
    private int userId;


    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        TextLogEntry that = (TextLogEntry) o;

        if (id != that.id) return false;
        if (textId != that.textId) return false;
        if (userId != that.userId) return false;
        if (creationDate != null ? !creationDate.equals(that.creationDate) : that.creationDate != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id;
        result = 31 * result + (creationDate != null ? creationDate.hashCode() : 0);
        result = 31 * result + textId;
        result = 31 * result + userId;
        return result;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public int getTextId() {
        return textId;
    }

    public void setTextId(int textId) {
        this.textId = textId;
    }

    public int getUserId() {
        return userId;
    }

    public void setUserId(int userId) {
        this.userId = userId;
    }
}