package com.dominikdorn.lyrix.domain;

import javax.persistence.*;
import java.util.Date;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@Table(name = "lyttextrating", schema = "lyriks")
@Entity
public class TextRating {

    @Id
    @Column(name = "ntextratingnr")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "text_rating_gen")
    @SequenceGenerator(name = "text_rating_gen", sequenceName = "lyttextrating_ntextratingnr_seq", allocationSize = 1)
    private int id;

    @Column(name = "ntextnr")
    @Basic
    private int textId;

    @Column(name = "nusernr")
    @Basic
    private int userId;


    @Column(name = "npoints")
    @Basic
    private int points;

    @Column(name = "dnow")
    @Basic
    @Temporal(TemporalType.TIMESTAMP)
    private Date creationDate;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        TextRating that = (TextRating) o;

        if (points != that.points) return false;
        if (textId != that.textId) return false;
        if (id != that.id) return false;
        if (userId != that.userId) return false;
        if (creationDate != null ? !creationDate.equals(that.creationDate) : that.creationDate != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id;
        result = 31 * result + textId;
        result = 31 * result + userId;
        result = 31 * result + points;
        result = 31 * result + (creationDate != null ? creationDate.hashCode() : 0);
        return result;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public int getTextId() {
        return textId;
    }

    public void setTextId(int textId) {
        this.textId = textId;
    }

    public int getUserId() {
        return userId;
    }

    public void setUserId(int userId) {
        this.userId = userId;
    }

    public int getPoints() {
        return points;
    }

    public void setPoints(int points) {
        this.points = points;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }
}