package com.dominikdorn.lyrix.domain;

import javax.persistence.*;
import java.sql.Date;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@IdClass(TopUserEntryPK.class)
@Table(name = "stttopuser", schema = "lyriks")
@Entity
public class TopUserEntry {
    @Column(name = "dtoday")
    @Id
    private Date date;

    @Column(name = "nusernr")
    @Id
    private int userId;

    @Column(name = "nrang")
    @Id
    private int rank;

    @Column(name = "ntexts")
    @Basic
    private int textCount;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        TopUserEntry that = (TopUserEntry) o;

        if (rank != that.rank) return false;
        if (textCount != that.textCount) return false;
        if (userId != that.userId) return false;
        if (date != null ? !date.equals(that.date) : that.date != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = date != null ? date.hashCode() : 0;
        result = 31 * result + userId;
        result = 31 * result + rank;
        result = 31 * result + textCount;
        return result;
    }


    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public int getUserId() {
        return userId;
    }

    public void setUserId(int userId) {
        this.userId = userId;
    }

    public int getRank() {
        return rank;
    }

    public void setRank(int rank) {
        this.rank = rank;
    }

    public int getTextCount() {
        return textCount;
    }

    public void setTextCount(int textCount) {
        this.textCount = textCount;
    }
}