package com.dominikdorn.lyrix.domain;

import javax.persistence.*;
import java.sql.Date;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@Table(name = "sttusertexts", schema = "lyriks")
@Entity
public class UserTextEntry {
    @Id
    @Column(name = "nusertextsnr")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "genre_gen")
    @SequenceGenerator(name = "genre_gen", sequenceName = "genre_ngenrenr_seq", allocationSize = 1)
    private int id;


    @Column(name = "dnow")
    @Basic
    private Date creationDate;


    @Column(name = "ntexts")
    @Basic
    private int textCount;

    @Column(name = "nuser")
    @Basic
    private int userCount;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        UserTextEntry that = (UserTextEntry) o;

        if (textCount != that.textCount) return false;
        if (userCount != that.userCount) return false;
        if (id != that.id) return false;
        if (creationDate != null ? !creationDate.equals(that.creationDate) : that.creationDate != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id;
        result = 31 * result + (creationDate != null ? creationDate.hashCode() : 0);
        result = 31 * result + textCount;
        result = 31 * result + userCount;
        return result;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public int getTextCount() {
        return textCount;
    }

    public void setTextCount(int textCount) {
        this.textCount = textCount;
    }

    public int getUserCount() {
        return userCount;
    }

    public void setUserCount(int userCount) {
        this.userCount = userCount;
    }
}