package com.dominikdorn.lyrix.domain;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlRootElement;
import java.util.Date;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@Table(name = "lytvideo", schema = "lyriks")
@Entity
@XmlRootElement
public class Video {
    @Id
    @Column(name = "nvideonr")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "video_gen")
    @SequenceGenerator(name = "video_gen", sequenceName = "lytvideo_nvideonr_seq", allocationSize = 1)
    private int id;

    @Column(name = "nusernr")
    @Basic
    private int userId;


    @Column(name = "dnow")
    @Basic
    @Temporal(TemporalType.TIMESTAMP)
    private Date creationDate;

    @Column(name = "nstatusnr")
    @Basic
    private int statusId;

    @Column(name = "sid")
    @Basic
    private String remoteId;

    @ManyToOne
    @JoinColumn(name = "ntitlenr", referencedColumnName = "ntitlenr", nullable = false)
    private Title title;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Video video = (Video) o;

        if (statusId != video.statusId) return false;
        if (userId != video.userId) return false;
        if (id != video.id) return false;
        if (creationDate != null ? !creationDate.equals(video.creationDate) : video.creationDate != null) return false;
        if (remoteId != null ? !remoteId.equals(video.remoteId) : video.remoteId != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id;
        result = 31 * result + userId;
        result = 31 * result + (creationDate != null ? creationDate.hashCode() : 0);
        result = 31 * result + statusId;
        result = 31 * result + (remoteId != null ? remoteId.hashCode() : 0);
        return result;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public int getUserId() {
        return userId;
    }

    public void setUserId(int userId) {
        this.userId = userId;
    }

    public Date getCreationDate() {
        return creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public int getStatusId() {
        return statusId;
    }

    public void setStatusId(int statusId) {
        this.statusId = statusId;
    }

    public String getRemoteId() {
        return remoteId;
    }

    public void setRemoteId(String remoteId) {
        this.remoteId = remoteId;
    }

    public Title getTitle() {
        return title;
    }

    public void setTitle(Title title) {
        this.title = title;
    }
}