package com.dominikdorn.lyrix.domain;

import javax.persistence.*;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@Table(name = "lytvideosource", schema = "lyriks")
@Entity
public class VideoSource {
    @Id
    @Column(name = "nvideosourcenr")
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "videosource_gen")
    @SequenceGenerator(
            name = "videosource_gen",
            sequenceName = "lytvideosource_nvideosourcenr_seq",
    allocationSize = 1)
    private int id;

    @Column(name = "sname")
    @Basic
    private String name;

    @Column(name = "surl")
    @Basic
    private String url;


    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        VideoSource that = (VideoSource) o;

        if (id != that.id) return false;
        if (name != null ? !name.equals(that.name) : that.name != null) return false;
        if (url != null ? !url.equals(that.url) : that.url != null) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id;
        result = 31 * result + (name != null ? name.hashCode() : 0);
        result = 31 * result + (url != null ? url.hashCode() : 0);
        return result;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }
}