package com.dominikdorn.lyrix.rs.resources;

import com.dominikdorn.lyrix.domain.Title;
import com.dominikdorn.lyrix.service.dc.UserService;
import com.dominikdorn.lyrix.service.lyrics.TitleService;

import javax.annotation.ManagedBean;
import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import javax.transaction.*;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.SecurityContext;
import java.util.List;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@Path("/api/lyrics/titles")
@ManagedBean
public class TitleResource {

    @Inject
    TitleService titleService;

    @Inject
    UserService userService;

    @Inject
    UserTransaction tx;

    @GET
    @Produces("application/json")
    @Path("/{artistId: [0-9]+}")
    public List<Title> getTitles(@PathParam("artistId") Long artistId)
    {
         return null;
    }


    @POST
    @Produces(MediaType.APPLICATION_JSON)
    public Title createTitle(@FormParam("name") String titleName,
                             @FormParam("artistId") long artistId,
                             @Context SecurityContext securityContext)
    {
        if(null == securityContext.getUserPrincipal())
            return null;
        
        String username = securityContext.getUserPrincipal().getName();

        long userId = userService.getUserId(username);

        if(userId < 1)
            return null;

        try {
            Title t = null;
            tx.begin();
            t = titleService.create(titleName, artistId, userId);
            tx.commit();
            return t;
        } catch (NotSupportedException e) {
            throw new RuntimeException(e);
        } catch (SystemException e) {
            throw new RuntimeException(e);
        } catch (RollbackException e) {
            throw new RuntimeException(e);
        } catch (HeuristicMixedException e) {
            throw new RuntimeException(e);
        } catch (HeuristicRollbackException e) {
            throw new RuntimeException(e);
        }
    }

    @GET
    @Path("/")
    @Produces("text/plain")
    public String defaultValue(){
        return "/titles/";
    }
}
