package com.dominikdorn.lyrix.service.dc;

import javax.annotation.ManagedBean;
import javax.enterprise.inject.Typed;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@ManagedBean
@Typed(UserService.class)
public class UserServiceImpl implements UserService {

    @PersistenceContext(unitName = "lyrixPU")
    EntityManager em;

    @Override
    public long getUserId(String username) {
        if(null == username)
            return 0;

        Integer userId =
                (Integer) em.
                        createNativeQuery
                                ("SELECT a.nusernr FROM core_usge.user a WHERE a.suserid = ?").
                setParameter(1, username).getSingleResult();

        return new Long(userId);
    }

    @Override
    public String getUsername(long id) {
        if(id < 1)
            return null;

        String username =

                (String) em.
                        createNativeQuery
                                ("SELECT a.suserid FROM core_usge.user a WHERE a.nusernr = ?").
                setParameter(1, id).getSingleResult();


        return username;
    }

    @Override
    public String getEmailAddress(long id) {
        if(id < 1)
            return null;

        String emailAddress =

                (String) em.
                        createNativeQuery
                                ("SELECT a.semail FROM core_usda.emailaddress a WHERE a.nusernr = ?").
                setParameter(1, id).getSingleResult();

        return emailAddress;
    }

    @Override
    public String getEmailAddress(String username) {
        if(null == username)
            return null;

        String emailAddress =
                (String) em.
                        createNativeQuery
                                ("SELECT a.semail FROM core_usge.user u JOIN core_usda.emailaddress a ON (u.suserid = ? AND a.nusernr = u.nusernr)").
                setParameter(1, username).getSingleResult();
        return emailAddress;
    }
}
