package com.dominikdorn.lyrix.service.lyrics;

import com.dominikdorn.lyrix.domain.Artist;
import com.dominikdorn.lyrix.domain.Title;

import java.util.List;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
public interface ArtistService {


    public List<Artist> getArtistsByLetter(String letter);

    /**
     * Creates an Artist, sets the given name and userId
     * and populates the other fields as required
     * @param name
     * @param userId
     * @return
     */
    public Artist createArtist(String name, long userId);


    /**
     * Returns the titles associated to this artistId
     * @param artistId
     * @return
     */
    public List<Title> getTitles(long artistId);


    /**
     * Searches for a artist by a substring of the name
     * @param name
     * @return
     */
    public List<Artist> searchByName(String name);

    public Artist findById(long id);
}
