package com.dominikdorn.lyrix.service.lyrics;

import com.dominikdorn.lyrix.dao.TextDao;
import com.dominikdorn.lyrix.domain.Text;

import javax.annotation.ManagedBean;
import javax.enterprise.inject.Typed;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.UUID;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
@ManagedBean
@Typed(LyricsService.class)
public class LyricsServiceImpl implements LyricsService {

    @PersistenceContext
    EntityManager em;

    @Inject
    TextDao textDao;

    @Override
    public boolean doesExist(String textHash) {
        return false;  //To change body of implemented methods use File | Settings | File Templates.
    }

    @Override
    public Text createText(long titleId, String text, long typeId, String language, long userId) {
        if(titleId < 1)
            return null;

        if(null == text || text.isEmpty())
            return null;

            /**
     * 110  	lyttext	lyric	Lyrics
     * 120  	lyttext	translation	&Uuml;bersetzung
     * 130  	lyttext	accord	Akkord
     * 140  	lyttext	tab	Tabulator
     */
        if(!(typeId == 110 || typeId == 120 || typeId == 130 || typeId == 140))
            return null;

//        langu?age = language.toLowerCase();
        
        Text t = new Text(titleId, text, userId, typeId, language);
       
        t = textDao.create(t);
        return t;
    }
}
