package com.dominikdorn.lyrix.service.lyrics;

import com.dominikdorn.lyrix.dao.TitleDao;
import com.dominikdorn.lyrix.domain.ArtistTitle;
import com.dominikdorn.lyrix.domain.Title;

import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.Date;
import java.util.List;

/**
 * Dominik Dorn
 * 0626165
 * dominik.dorn@tuwien.ac.at
 */
public class TitleServiceImpl implements TitleService {
    @PersistenceContext
    EntityManager em;

    @Inject
    TitleDao titleDao;

    @Override
    public Title create(String name, long artistId, long userId) {

        Title t = new Title();
        t.setName(name);
        t.setUserId(userId);
        t.setStatusId(1260);
        t.setTypeId(210);
        t.setCreationDate(new Date());
        t.setSeconds(0l);
        t.setSoundex("");


        t = titleDao.create(t);

        ArtistTitle at = new ArtistTitle();
        at.setArtistId(artistId);
        at.setTitleId(t.getId());
        at.setUserId(userId);
        at.setCreationDate(new Date());
        at.setStatusId(1560);


        em.persist(at);
        return t;
    }

    @Override
    public List countTexts(long titleId) {        
        return em.createNativeQuery(
        "select ntypenr,count( *) as anz from lyttext where ntitlenr = ? and nstatusnr IN ( 1110,1160) GROUP BY ntypenr")
                .setParameter(1, titleId).getResultList();
    }
}
